procedure btc_dochipscales(basename,divone,divtwo,divthree,divfour)

# apply chip-to-chip photometric scalings to btc image sets
# redoing of iterstat is not done by default because it may have been done in
#	the focasflat step
# 990723: skips over missing images

string  basename	{prompt="Full base name of image set to normalize"}
real	divone		{prompt="Scaling factor to divide into chip #1"}
real	divtwo		{prompt="Scaling factor to divide into chip #2"}
real	divthree	{prompt="Scaling factor to divide into chip #3"}
real	divfour		{prompt="Scaling factor to divide into chip #4"}
bool	doiterstat	{no,prompt="Rerun iterstat on the final scaled images?"}
string  imextn="fits"	{prompt="Extension of images (imh, fits, etc.)"}
bool    echog           {yes,prompt="Beep when task is done?"}
struct  *name

begin

string	base, image, scales, im_extn
real 	avgmean, chipscale, dvone, dvtwo, dvthree, dvfour, divisor
bool	redoiterstat

# -- cycle through images
base = basename
dvone = divone
dvtwo = divtwo
dvthree = divthree
dvfour = divfour
redoiterstat = doiterstat
im_extn = imextn

# -- do the scaling
for (i=1; i<=4; i+=1) {
    image = base//"_"//i//"."//im_extn
    if(!access(image)) {
	print ("WARNING!  Cannot access "//image)
    } else {
	if(i==1){
		imgets (image, "chipscal", >& "dev$null")
                if ((imgets.value)=="0") {
			print ("Dividing "//image//" by "//dvone)
			imar (image, "/", dvone, image, ver-, noact-)
			hedit(image,"chipscal",dvone,add+,ver-,show+,update+)
# -- update the iterstat parameters in the image headers
	if (redoiterstat) {
	  print ("Rerunning iterstat on "//image)
	  iterstat (image, print+, ver-, addh+)
	} else {
	  hedit(image,"itermean","(itermean/"//dvone//")",add+,ve-,sho-,updat+)
	  hedit(image,"itermode","(itermode/"//dvone//")",add+,ve-,sho-,updat+)
	  hedit(image,"itersig","(itersig/"//dvone//")",add+,ve-,sho-,updat+)
	  hedit(image,"itermed","(itermed/"//dvone//")",add+,ve-,sho-,updat+)
	  hedit(image,"variance","(variance/("//dvone//"*"//dvone//"))",add+,ve-,sho-,updat+)
	}
		} else {
			print (image//" already divided by "//imgets.value)
		}
	}
	if(i==2){
		imgets (image, "chipscal", >& "dev$null")
                if ((imgets.value)=="0") {
			print ("Dividing "//image//" by "//dvtwo)
			imar (image, "/", dvtwo, image, ver-, noact-)
			hedit(image,"chipscal",dvtwo,add+,ver-,show+,update+)
# -- update the iterstat parameters in the image headers
	if (redoiterstat) {
	  print ("Rerunning iterstat on "//image)
	  iterstat (image, print+, ver-, addh+)
	} else {
	  hedit(image,"itermean","(itermean/"//dvtwo//")",add+,ve-,sho-,updat+)
	  hedit(image,"itermode","(itermode/"//dvtwo//")",add+,ve-,sho-,updat+)
	  hedit(image,"itersig","(itersig/"//dvtwo//")",add+,ve-,sho-,updat+)
	  hedit(image,"itermed","(itermed/"//dvtwo//")",add+,ve-,sho-,updat+)
	  hedit(image,"variance","(variance/("//dvtwo//"*"//dvtwo//"))",add+,ve-,sho-,updat+)
	}
		} else {
			print (image//" already divided by "//imgets.value)
		}
	}
	if(i==3){
		imgets (image, "chipscal", >& "dev$null")
                if ((imgets.value)=="0") {
			print ("Dividing "//image//" by "//dvthree)
			imar (image, "/", dvthree, image, ver-, noact-)
			hedit(image,"chipscal",dvthree,add+,ver-,show+,update+)
# -- update the iterstat parameters in the image headers
	if (redoiterstat) {
	  print ("Rerunning iterstat on "//image)
	  iterstat (image, print+, ver-, addh+)
	} else {
	  hedit(image,"itermean","(itermean/"//dvthree//")",ad+,ve-,sho-,updat+)
	  hedit(image,"itermode","(itermode/"//dvthree//")",ad+,ve-,sho-,updat+)
	  hedit(image,"itersig","(itersig/"//dvthree//")",add+,ve-,sho-,updat+)
	  hedit(image,"itermed","(itermed/"//dvthree//")",add+,ve-,sho-,updat+)
	  hedit(image,"variance","(variance/("//dvthree//"*"//dvthree//"))",add+,ve-,sho-,updat+)
	}
		} else {
			print (image//" already divided by "//imgets.value)
		}
	}
	if(i==4){
		imgets (image, "chipscal", >& "dev$null")
                if ((imgets.value)=="0") {
			print ("Dividing "//image//" by "//dvfour)
			imar (image, "/", dvfour, image, ver-, noact-)
			hedit(image,"chipscal",dvfour,add+,ver-,show+,update+)
# -- update the iterstat parameters in the image headers
	if (redoiterstat) {
	  print ("Rerunning iterstat on "//image)
	  iterstat (image, print+, ver-, addh+)
	} else {
	  hedit(image,"itermean","(itermean/"//dvfour//")",add+,ve-,sho-,updat+)
	  hedit(image,"itermode","(itermode/"//dvfour//")",add+,ve-,sho-,updat+)
	  hedit(image,"itersig","(itersig/"//dvfour//")",add+,ve-,sho-,updat+)
	  hedit(image,"itermed","(itermed/"//dvfour//")",add+,ve-,sho-,updat+)
	  hedit(image,"variance","(variance/("//dvfour//"*"//dvfour//"))",add+,ve-,sho-,updat+)
	}
		} else {
			print (image//" already divided by "//imgets.value)
		}
	}
    }
}

if(echog)beep

end


