procedure btc_maskaligntrim(im1,im2,im3,prefix,suffix)

# --trim images to areas with < 2/3 (rounded down) of input images
# --align B & R image to overlap region only
# --optionally align I image to that same region
#
# 980710: created
# 980724: blank regions of final images now have mean = rest of image
# 980726: option to delete intermediate 'good' images
# 000816: func=polynomial in immatch.geomap

string  im1     {prompt="Primary (reference) image"}
string  im2     {prompt="Secondary image"}
string  im3     {prompt="Tertiary image (optional)"}
string  prefix  {prompt="Prefix string for output files"}
string  suffix  {prompt="Suffix string for output files"}
bool domask=yes	{prompt="Mask image areas w/<2/3 max # of input images?"}
bool doalign=yes {prompt="Compute shifts to align images with each other?"}
bool  dotrim=yes {prompt="Trim images to primary-secondary overlap region?"}
bool  delold=no	 {prompt="Delete existing versions of intermediate files?"}
bool intract=yes {prompt="Fit x-y shifts interactively?"}
bool display=yes {prompt="Display final aligned images?"}
bool delgood=yes {prompt="Delete intermediate `good' images?"}
bool   echog        {yes,prompt="Beep when task is done?"}
struct  *name

begin

string  bimage, rimage, iimage, s1, s2, s3, image, pl, imroot, imext
string  imrootr, imrootb, imrooti, pprefix, ssuffix
real    x, y, alignmin, alignavg
int	xmin, ymin, xmax, ymax, i, j, k, numim, imnow, maxfrac, n, imax, imay
int	bxmin, bxmax, bymin, bymax, rxmax, rxmin, rymax, rymin, xoff, yoff
int	rxminoff, rxmaxoff, ryminoff, rymaxoff, ixmin, ixmax, iymin, iymax
int	bxnewmin, bxnewmax, bynewmin, bynewmax, rxnewmin, rxnewmax
int	rynewmin, rynewmax, ixnewmin, ixnewmax, iynewmin, iynewmax, iyoutmax
int	ixminoff, ixmaxoff, iyminoff, iymaxoff, ixoutmin, ixoutmax, iyoutmin
bool	maskdo, aligndo, trimdo, delex, intact, dsplay, dgood

bimage=im1
rimage=im2
iimage=im3
pprefix=prefix
ssuffix=suffix
maskdo=domask
aligndo=doalign
trimdo=dotrim
delex=delold
intact=intract
dsplay=display
dgood=delgood

numim=2
image=bimage
fileroot(bimage, validim+); imrootb=fileroot.root
fileroot(rimage, validim+); imrootr=fileroot.root
if(iimage!=""){
	numim=3
	fileroot(iimage, validim+); imrooti=fileroot.root
}

if(maskdo) {
#--for each image, mask out areas with <2/3 (rounded down) of all images
    print ("Masking out areas including <2/3 (rounded down) of input images...")
    for (imnow=1; imnow<=numim; imnow+=1) {
	if(imnow==2){image=rimage}
	if(imnow==3){image=iimage}
	hsel (image, "plfmask", yes) | scan (pl)
	fileroot(image, validim+)
	imroot=fileroot.root
	imext=fileroot.extension
	fileroot(pl, validim+)
	pl=fileroot.root

#--create trim masks from pixel list files
	if(delex)imdel(pl//"good.pl", ver-, >& "dev$null")
	if(!access(pl//"good.pl")){
		minmax (pl, force+, update-, ver-)
		maxfrac = minmax.maxval/3.
		imdel ("tmp"//pl//".pl", ver-, >& "dev$null")
		imar (pl,"-",maxfrac,"tmp"//pl//".pl",ver-,noact-,calct="real",pixt="1")
		print ("Ignore the following warning sign...")
		minv ("tmp"//pl, pl//"good.pl")
		imdel ("tmp"//pl, ver-)
	}

#--find x boundaries for trimming
	if(delex)imdel(pl//"trans.pl", ver-, >& "dev$null")
	if(!access(pl//"trans.pl"))imtransp(pl//"good.pl[*,-*]",pl//"trans.pl")
	minmax (pl//"trans.pl", force+, update-, ver-)
	s3=minmax.maxpix; i=stridx(",",s3); j=stridx("]",s3)
	s1=substr(s3,i+1,j-1); s1="["//s1//":"
	minmax (pl//"trans.pl[*,-*]", force+, update-, ver-)
	s3=minmax.maxpix; i=stridx(",",s3); j=stridx("]",s3)
	s2=substr(s3,i+1,j-1); k=real(s2)
	imgets (pl//"trans.pl", "i_naxis2")
	j=int(imgets.value); i=j-k+1; s1=s1//i//","
#	imdel (pl//"trans.pl", ver-)

#--find y boundaries for trimming
	minmax (pl//"good.pl", force+, update-, ver-)
	s3=minmax.maxpix; i=stridx(",",s3); j=stridx("]",s3)
	s2=substr(s3,i+1,j-1); s1=s1//s2//":"
	minmax (pl//"good.pl[*,-*]", force+, update-, ver-)
	s3=minmax.maxpix; i=stridx(",",s3); j=stridx("]",s3)
	s2=substr(s3,i+1,j-1); k=real(s2)
	imgets (pl//"good.pl", "i_naxis2")
	j=int(imgets.value); i=j-k+1; s1=s1//i//"]"

#--create trimmed images
	imdel("_tmp_"//image, ver-, >& "dev$null")
	imar(image,"*",pl//"good.pl","_tmp_"//image,ve-,noa-,calct="real",pixt="1")
	if(delex)imdel(imroot//"good", ver-, >& "dev$null")
	imcopy ("_tmp_"//image//s1, imroot//"good", ver+)
	hedit (imroot//"*", "goodsec", image//s1, add+, ver-, show-, upda+)
	imdel ("_tmp_"//image, ver-)

    }
}

if (aligndo) {
    print ("")
    print ("Running irshift2 to compute shifts needed to align images...")
    print ("")
#--do irshift2 & immatch.geomap on b & r images
    irshift2 (imrootb//"good", imrootr//"good", pprefix//"br", ssuffix)
    hsel (imrootb//"good", "i_naxis1", "yes") | scan (imax)
    hsel (imrootb//"good", "i_naxis2", "yes") | scan (imay)
    immatch.geomap (pprefix//"br.geomapin."//ssuffix, pprefix//"br.geomapout."//ssuffix, 1, imax, 1, imay, func="polynomial", fitgeo="shift", ver-, interact=intact)

#--do irshift2 & immatch.geomap on b & i images
    if(iimage!=""){
	irshift2 (imrootb//"good", imrooti//"good", pprefix//"bi", ssuffix)
	immatch.geomap (pprefix//"bi.geomapin."//ssuffix, pprefix//"bi.geomapout."//ssuffix, 1, imax, 1, imay, func="polynomial", fitgeo="shift", ver-, interact=intact)
    }
}

if (trimdo) {
    print ("Trimming images to overlap regions...")
#--figure out b & r trimming sections
#--extract real x & y offsets
    fields(pprefix//"br.geomapout."//ssuffix, "1,2", lines="26-26") | scan (x,y)
#--round off to nearest integer
    if(x>=0) {
	i=int(x+0.5)
    } else {
	i=-1*int(0.5-x)
    }
    if(y>=0) {
	j=int(y+0.5)
    } else {
	j=-1*int(0.5-y)
    }
#--get smallest & largest pixel coords of input primary image
    bxmin=1; hsel (imrootb//"good", "i_naxis1", yes) | scan (bxmax)
    bymin=1; hsel (imrootb//"good", "i_naxis2", yes) | scan (bymax)
    bxnewmin=bxmin; bxnewmax=bxmax; bynewmin=bymin; bynewmax=bymax
#--get ideal offset smallest pixel coords of output 2nd image
    rxminoff=1+i; ryminoff=1+j
#--get largest pixel coords of input 2nd image
    hsel (imrootr//"good", "i_naxis1", yes) | scan (rxmax)
    hsel (imrootr//"good", "i_naxis2", yes) | scan (rymax)
    rxnewmin=rxminoff; rynewmin=ryminoff
#--if ideal offset smallest pixel coords of output 2nd image <0, adjust to =1
    if(rxminoff<=0) {
	xoff=1-rxminoff; rxnewmin=1
	bxnewmin=bxmin+xoff
    }
    if(ryminoff<=0) {
	yoff=1-ryminoff; rynewmin=1
	bynewmin=bymin+yoff
    }
#--get ideal offset largest pixel coords of output 2nd image
    rxmaxoff=bxmax+i; rymaxoff=bymax+j; rxnewmax=rxmaxoff; rynewmax=rymaxoff
#--if ideal offset largest 2nd image pixel coords > than input 2nd image...
    if(rxmaxoff>rxmax) {
	xoff=rxmaxoff-rxmax; rxnewmax=rxmax
	bxnewmax=bxnewmax-xoff
    }
    if(rymaxoff>rymax) {
	yoff=rymaxoff-rymax; rynewmax=rymax
	bynewmax=bynewmax-yoff
    }
#--if the above has made the new b coord > max input b coord...
    if(bxnewmax>bxmax) {
	xoff=bxnewmax-bxmax; bxnewmax=bxmax
	rxnewmax=rxnewmax-xoff
    }
    if(bynewmax>bymax) {
	yoff=bynewmax-bymax; bynewmax=bymax
	rynewmax=rynewmax-yoff
    }
#--trim imroot//"good" to imroot//"align"
    print("Creating, iterstating, imreplacing "//imrootb//"align")
    imcopy (imrootb//"good["//bxnewmin//":"//bxnewmax//","//bynewmin//":"//bynewmax//"]", imrootb//"align")
    hedit (imrootb//"*", "alignsec", imrootb//"good["//bxnewmin//":"//bxnewmax//","//bynewmin//":"//bynewmax//"]", add+, ver-, show-, update+)
    iterstat (imrootb//"align", nsigrej=5., maxiter=10, print-, ver-, addh+, lower=1, upper=INDEF)
    minmax (imrootb//"align", force+, update-, ver-)
    alignmin=minmax.minval
    if (alignmin<=0.) {
    	print("Now imreplacing "//imrootb//"align")
	alignavg=iterstat.mean
	imreplace(imrootb//"align", alignavg, low=INDEF, upp=1., rad=0.)
    }
    print("Creating, iterstating, imreplacing "//imrootr//"align")
    imcopy (imrootr//"good["//rxnewmin//":"//rxnewmax//","//rynewmin//":"//rynewmax//"]", imrootr//"align")
    hedit (imrootr//"*", "alignsec", imrootr//"good["//rxnewmin//":"//rxnewmax//","//rynewmin//":"//rynewmax//"]", add+, ver-, show-, update+)
    iterstat (imrootr//"align", nsigrej=5., maxiter=10, print-, ver-, addh+, lower=1, upper=INDEF)
    minmax (imrootr//"align", force+, update-, ver-)
    alignmin=minmax.minval
    if (alignmin<=0.) {
    	print("Now imreplacing "//imrootr//"align")
	alignavg=iterstat.mean
	imreplace(imrootr//"align", alignavg, low=INDEF, upp=1., rad=0.)
    }
#--figure out i trimming sections; non-overlap regions have mean=rest of img
    if(iimage!=""){
	print ("Now working on "//imrooti)
#--create blank i image from b image
	imar (imrootb//"align", "-", imrootb//"align", imrooti//"align", pixt="1", calct="real", ver-, noact-)
#--extract real x & y offsets
	fields(pprefix//"bi.geomapout."//ssuffix, "1,2", lines="26-26") | scan (x,y)
#--round off to nearest integer
	if(x>=0) {
		i=int(x+0.5)
	} else {
		i=-1*int(0.5-x)
	}
	if(y>=0) {
		j=int(y+0.5)
	} else {
		j=-1*int(0.5-y)
	}
#--get ideal output size of output 3rd image
	ixoutmin=1; hsel (imrootb//"align", "i_naxis1", yes) | scan (ixoutmax)
	iyoutmin=1; hsel (imrootb//"align", "i_naxis2", yes) | scan (iyoutmax)
#--get ideal offset smallest & largest pixel coords to go into output 3rd image
	ixminoff=bxnewmin+i; iyminoff=bynewmin+j
	ixmaxoff=bxnewmax+i; iymaxoff=bynewmax+j
	ixnewmin=ixminoff;ixnewmax=ixmaxoff;iynewmin=iyminoff;iynewmax=iymaxoff
#--get largest pixel coords of input 3rd image
	hsel (imrooti//"good", "i_naxis1", yes) | scan (ixmax)
	hsel (imrooti//"good", "i_naxis2", yes) | scan (iymax)
#--if ideal offset smallest pixel coords of output 3rd image <0, adjust to =1
	if(ixminoff<=0) {
		xoff=1-ixminoff; ixnewmin=1; ixoutmin=1+xoff
	}
	if(iyminoff<=0) {
		yoff=1-iyminoff; iynewmin=1; iyoutmin=1+yoff
	}
#--if ideal offset largest pixel coords of output 3rd image > input 3rd image...
	if(ixmaxoff>ixmax) {
		xoff=ixmaxoff-ixmax; ixnewmax=ixmax; ixoutmax=ixoutmax-xoff
	}
	if(iymaxoff>iymax) {
		yoff=iymaxoff-iymax; iynewmax=iymax; iyoutmax=iyoutmax-yoff
	}
    	print("Creating & iterstating "//imrooti//"align")
	imcopy (imrooti//"good["//ixnewmin//":"//ixnewmax//","//iynewmin//":"//iynewmax//"]", imrooti//"align["//ixoutmin//":"//ixoutmax//","//iyoutmin//":"//iyoutmax//"]")
	hedit (imrooti//"*", "alignsec", imrooti//"good["//ixnewmin//":"//ixnewmax//","//iynewmin//":"//iynewmax//"] -> ["//ixoutmin//":"//ixoutmax//","//iyoutmin//":"//iyoutmax//"]", add+, ver-, show-, update+)
	iterstat (imrooti//"align", nsigrej=5., maxiter=10, print-, ver-, addh+, lower=1, upper=INDEF)
	minmax (imrooti//"align", force+, update-, ver-)
	alignmin=minmax.minval
	if (alignmin<=0.) {
    		print("Now imreplacing "//imrooti//"align")
		alignavg=iterstat.mean
		imreplace(imrooti//"align", alignavg, low=INDEF, upp=1., rad=0.)
	}
    }

#--display if desired
    if(dsplay) {
    	print("Displaying aligned images...")
	displ (imrootb//"align", 1)
	displ (imrootr//"align", 2)
	if(iimage!="")displ(imrooti//"align", 3)
    }

#--delete good images if desired
    if(dgood) {
	print("Deleting intermediate `good' images...")
	imdel (imrootb//"good", ver-)
	imdel (imrootr//"good", ver-)
	if(iimage!="")imdel(imrooti//"good", ver-)
    }

}

if(echog)beep

end

