procedure btc_saulflip(filename)

# Update SNe search image headers to gain=1, and flip all N-S
# 980703: add addsky and badfixpix parameters
# 990525: add BPMASK to header as well as BPM

string  filename	{prompt="List of old and new image names"}
string	bpmroot=""	{prompt="Root name of bad pixel masks to add to header"}
string	getstats=""	{prompt="File name for iterstat output if desired"}
bool	addsky=yes	{prompt="Add SKY level back in?"}
bool	badpixfix=yes	{prompt="Interpolate over bad pixels using fixpix?"}
bool	cleanup=yes	{prompt="Remove old images?"}
bool   echog        {yes,prompt="Beep when task is done?"}
struct  *name

# filename should list the names of the root image to be worked on

begin

string	root, image, scales, bbpmroot, ggetstats, oldname, newname
real 	iteravg, chipscale, sky
bool	ccleanup, aaddsky, bbadpixfix

bbpmroot=bpmroot
ggetstats=getstats
aaddsky=addsky
bbadpixfix=badpixfix
ccleanup=cleanup

# -- cycle through image sets
name = filename
while (fscan (name, oldname, newname) != EOF) {
	hsel (oldname, "ampid", yes) | scan i
# -- update gain value in header
	imgets(oldname, "gainold", >& "dev$null")
	if ((imgets.value)=="0") {
		imgets(oldname, "gain", >& "dev$null")
		hedit (oldname,"gainold","(gain)",add+,ve-,sho+,updat+)
		hedit (oldname,"gain",1.0,add+,ve-,sho+,updat+)
	} else {
		print (oldname//" header already updated to gain=1!")
	}
# -- flip chips N-S
        imgets(oldname, "flipns", >& "dev$null")
        if ((str(imgets.value)) != "yes") {
        	imgets(oldname, "flip", >& "dev$null")
        	if ((str(imgets.value)) != "yes") {
        		imcopy (oldname//"[*,-*]", newname, ver-)
        		if (ccleanup) imdel (oldname, ver-)
        		hedit(newname,"flipns","yes",add+,ve-,sho+,updat+)
                    	hedit(newname,"flip","yes",add+,ve-,sho+,updat+)
			print (newname//" flipped N-S...")
                } else { 
                     	print (oldname//" already flipped N-S!")
                 	hedit(oldname,"flipns","yes",add+,ve-,sho+,updat+)
            	}
	} else { 
        	print (oldname//" already flipped N-S!")
        	hedit(oldname,"flip","yes",add+,ve-,sho+,updat+)
	}
# -- add bad pixel mask names to headers
	if (bbpmroot!="") {
	  hedit(newname,"BPM",bbpmroot//"_"//i//".pl",add+,ver-,sho+,updat+)
	  hedit(newname,"BPMASK",bbpmroot//"_"//i//".pl",add+,ver-,sho+,updat+)
	}
# -- add sky back in if desired
    if (aaddsky) {
	imgets(newname, "addsky", >& "dev$null")
	if ((str(imgets.value))!="yes") {
		imgets(newname, "sky", >& "dev$null")
		if ((imgets.value)!="0") {
			print ("Adding sky back in to "//newname//"...")
			sky = real(imgets.value)
			imar (newname, "+", sky, newname, ver-, noact-, pixt="real", calct="real")
			hedit (newname,"addsky","yes",add+,ver-,show+,update+)
			imgets(newname, "itermean", >& "dev$null")
			if ((imgets.value)!="0") {
				hedit(newname,"itermean","(itermean+sky)",add+,ve-,sho-,updat+)
				hedit(newname,"itermode","(itermode+sky)",add+,ve-,sho-,updat+)
				hedit(newname,"itermed","(itermed+sky)",add+,ve-,sho-,updat+)
			}
		} else {
			print (newname//" does not contain SKY header keyword!")
		}
	} else {
		print (newname//" already has ADDSKY header keyword!")
	}
    }
# -- fixpix if desired
    if (bbadpixfix) {
	imgets(newname, "fixpix", >& "dev$null")
	if ((imgets.value)=="0") {
		imgets(newname, "BPM", >& "dev$null")
		if ((imgets.value)!="0") {
			fixpix (newname, "BPM", linterp=1, cinterp=INDEF, ver+, pixels+)
		} else {
			print (newname//" does not contain BPM header keyword!")
		}
	} else {
		print (newname//" has already had FIXPIX done!")
	}
    }
# -- iterstat if desired
	if (ggetstats!="") {
	  print (newname//" flipped and header updated.  Running iterstat.")
	  iterstat (newname, print+, ver-, addh+, >> ggetstats)
	}
}

if(echog)beep

end



