# offset.cl -- Find the offset on the sky between two objects.
#
# This task takes the ID numbers and coordinates of two objects and computes 
# the offset on the sky between them, in seconds of time E-W and arcsec N-S,
# as well as the distance between them in arcminutes.
# Optionally these values can be output to a file instead of STDOUT.
#
#procedure offset(num1,ir1,id1,num2,ir2,id2)
procedure offset(list1,list2)

#string num1 {prompt = "ID number of CANDIDATE"}
#real ir1 {prompt = "RA coordinate of CANDIDATE"}
#real id1 {prompt = "Dec coordinate of CANDIDATE"}
#string num2 {prompt = "ID number of OFFSET STAR"}
#real ir2 {prompt = "RA coordinate of OFFSET STAR"}
#real id2 {prompt = "Dec coordinate of OFFSET STAR"}
string list1 {prompt = "First list of coordinates"}
string list2 {prompt = "Second list of coordinates"}
string outfile="STDOUT" {prompt = "Output file"}
struct *el1
struct *el2

begin

string ir1, ir2, id1, id2, num1, num2
real dist, cdist, sdist, tdist, rn1, rn2, dn1, dn2, rt1, rt2, sigdig
real rd, dd, rds, dds, dt1, dt2, r1, r2, d1, d2
real pi=3.141592653585
string ooutlist
ooutlist=outfile

el1=list1
el2=list2

while(fscan(el1,ir1,id1,num1) !=EOF) {

	while(fscan(el2,ir2,id2,num2) !=EOF) {

#set up dummy variables
	r1=real(ir1)
	d1=real(id1)
	r2=real(ir2)
	d2=real(id2)
#convert input RA to degrees
        rt1=15.0*r1
        rt2=15.0*r2
#convert input RA,dec to radians
        rn1=rt1*pi/180.0
        rn2=rt2*pi/180.0
        dn1=d1*pi/180.0
        dn2=d2*pi/180.0
#compute the distance using the formula:
#cosine(distance) = sin(d1)*sin(d2) + cos(d1)cos(d2)cos(r1-r2)
#theta=atan2(y,x)
        cdist = sin(dn1)*sin(dn2) + cos(dn1)*cos(dn2)*cos(rn1-rn2)
        sdist = sqrt(1.00 - cdist**2)
        tdist = atan2(sdist,cdist)
        dist = tdist*180.00/pi

#delta ra and dec
	rd=(rt2-rt1)*cos((dn1+dn2)/2.)
	dd=d2-d1

#Option 2: difference in RA and Dec (accurate for small separations only)
#       print("E-W on-sky separation in seconds of time: "//rd*240, >> ooutlist)
       print("E-W on-sky separation in arcsec: "//rd*3600, >> ooutlist)
       print("N-S on-sky separation in arcsec: "//dd*3600, >> ooutlist)
       print(num1//" is "//dist*60//" arcmin from "//num2, >> ooutlist)

	}

}

end

